package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.PVPart;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class PVPartSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<PVPart> selectCond;
	private JSONObject customsearchval;
	public PVPartSearchFilter(){
		this.page =new Page<PVPart>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<PVPart>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_portalpageid_eq;

	public void setN_portalpageid_eq(String n_portalpageid_eq) {
        this.n_portalpageid_eq = n_portalpageid_eq;
        if(!StringUtils.isEmpty(this.n_portalpageid_eq)){
            this.selectCond.eq("portalpageid", n_portalpageid_eq);
        }
    }
	private String n_portalpagename_eq;

	public void setN_portalpagename_eq(String n_portalpagename_eq) {
        this.n_portalpagename_eq = n_portalpagename_eq;
        if(!StringUtils.isEmpty(this.n_portalpagename_eq)){
            this.selectCond.eq("portalpagename", n_portalpagename_eq);
        }
    }
	private String n_portalpagename_like;

	public void setN_portalpagename_like(String n_portalpagename_like) {
        this.n_portalpagename_like = n_portalpagename_like;
        if(!StringUtils.isEmpty(this.n_portalpagename_like)){
            this.selectCond.like("portalpagename", n_portalpagename_like);
        }
    }
	private String n_pvpartname_like;

	public void setN_pvpartname_like(String n_pvpartname_like) {
        this.n_pvpartname_like = n_pvpartname_like;
        if(!StringUtils.isEmpty(this.n_pvpartname_like)){
            this.selectCond.like("pvpartname", n_pvpartname_like);
        }
    }
	private String n_pvparttype_eq;

	public void setN_pvparttype_eq(String n_pvparttype_eq) {
        this.n_pvparttype_eq = n_pvparttype_eq;
        if(!StringUtils.isEmpty(this.n_pvparttype_eq)){
            this.selectCond.eq("pvparttype", n_pvparttype_eq);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_PVPART_PORTALPAGE_PORTALPAGEID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_portalpageid_eq("NA");
			}
			else{
				this.setN_portalpageid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("pvpartname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}